diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
index 6e428881a..95afc0524 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -8,6 +8,8 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 
+import com.mojang.logging.CategorizedLogger;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
 import net.minecraft.core.util.helper.Buffer;
 
@@ -17,6 +19,7 @@ import net.minecraft.core.util.helper.Buffer;
  * <br> Entries can be toggled visible or invisible quickly
  */
 public class RenderList {
+	private static final CategorizedLogger LOGGER = LogUtils.getLogger();
 	
 	public final VertexBuffer vertexBuffer;
 	
@@ -150,7 +153,7 @@ public class RenderList {
 		if(buffer.capacity() < requiredCapacity) {
 			int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
 			
-			System.out.println("Expand RenderList IntBuffer " + buffer.capacity() + " -> " + newCapacity);
+			LOGGER.warn("Expanding RenderList IntBuffer from " + buffer.capacity() + " to " + newCapacity + " ints...");
 			
 			return Buffer.createBuffer(newCapacity << 2).asIntBuffer();
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index 655877eb9..6b2ed0a73 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -7,6 +7,8 @@ import java.nio.ByteOrder;
 import java.util.ArrayList;
 import java.util.List;
 
+import com.mojang.logging.CategorizedLogger;
+import com.mojang.logging.LogUtils;
 import org.lwjgl.opengl.GL31;
 
 import net.minecraft.client.render.OpenGLHelper;
@@ -17,7 +19,7 @@ import net.minecraft.client.render.OpenGLHelper;
  * <br> When the buffer is full, it will automatically expand
  */
 public class VertexBuffer {
-	
+	public static final CategorizedLogger LOGGER = LogUtils.getLogger();
 	private int vbo;
 	private long capacity;
 	
@@ -118,8 +120,8 @@ public class VertexBuffer {
 			// future proof
 			throw new RuntimeException();
 		}
-		
-		System.out.println("Expand VBO Buffer: " + newCapacity);
+
+		LOGGER.warn("Expand VBO Buffer: " + newCapacity);
 		
 		OpenGLHelper.checkError("pre expand buffer");
 		
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index 7d968f262..7caf870bd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -47,11 +47,11 @@ public class AtlasStitcher extends Texture {
         this.mipmap = mipmap;
         this.defaultTexture = defaultTexture;
     }
-    protected IconCoordinate getTexture(@NotNull NamespaceID id){
+    protected IconCoordinate getTexture(@NotNull NamespaceID sourceId, @NotNull NamespaceID id){
         if (textureMap.containsKey(id)) return textureMap.get(id);
 
 
-        IconCoordinate iconCoordinate = new IconCoordinate(this, id, getSourceImagePath(id));
+        IconCoordinate iconCoordinate = new IconCoordinate(this, sourceId, id, getSourceImagePath(id));
         textureMap.put(id, iconCoordinate);
         return iconCoordinate;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index baa93cde0..d169f72d3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -21,10 +21,12 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     protected final String sourceImage;
     protected final TextureMetaHandler metaHandler = new TextureMetaHandler();
     public final NamespaceID namespaceId;
+    public final NamespaceID sourceNamespaceId;
     public final AtlasStitcher parentAtlas;
     private BufferedImage _imageStorage;
-    public IconCoordinate(AtlasStitcher stitcher, NamespaceID namespaceId, String sourceImage){
+    public IconCoordinate(AtlasStitcher stitcher, NamespaceID sourceNamespaceId, NamespaceID namespaceId, String sourceImage){
         this.parentAtlas = stitcher;
+        this.sourceNamespaceId = sourceNamespaceId;
         this.namespaceId = namespaceId;
         this.sourceImage = sourceImage;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index d1da1f01c..58c39dfbb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -27,6 +27,7 @@ import java.util.stream.Stream;
 public class TextureRegistry {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static HashMap<String, AtlasStitcher> stitcherMap = new HashMap<>();
+    protected static HashMap<AtlasStitcher, String> stitcherMapReverse = new HashMap<>();
     @SuppressWarnings("unused")
     public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", false, true, "/assets/minecraft/textures/block/texture_missing.png"));
     @SuppressWarnings("unused")
@@ -57,7 +58,7 @@ public class TextureRegistry {
             target.append("/").append(split2[i]);
         }
 
-        return atlas.getTexture(new NamespaceID(id.namespace, target.toString()));
+        return atlas.getTexture(id, new NamespaceID(id.namespace, target.toString()));
     }
     public static boolean hasTexture(@NotNull String key) {
         try {
@@ -80,6 +81,7 @@ public class TextureRegistry {
     }
     public static AtlasStitcher register(String id, AtlasStitcher atlas){
         stitcherMap.put(id, atlas);
+        stitcherMapReverse.put(atlas, id);
         return atlas;
     }
     static {
@@ -101,7 +103,8 @@ public class TextureRegistry {
 //        System.out.println("Printing " + path);
         for (String s : files) {
 //            System.out.println(s);
-            atlas.getTexture(new NamespaceID(namespace, s.replace(".png", "").replace("//", "/")));
+            NamespaceID id = new NamespaceID(namespace, s.replace(".png", "").replace("//", "/"));
+            atlas.getTexture(new NamespaceID(id.namespace, stitcherMapReverse.get(atlas) + "/" + id.value), id);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 30261446e..51ba2a7a7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.texturepack;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.KeyboardLayout;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
@@ -96,6 +97,8 @@ public class TexturePackList
 		}
 		mc.textureManager.updateDynamicTextures(false);
 		SoundRepository.reload();
+
+		KeyboardLayout.defaultLayout = new KeyboardLayout();
 	}
 
 	public boolean updateAvailableTexturePacks() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/CursorShape.java b/game/client/src/main/java/net/minecraft/client/render/window/CursorShape.java
new file mode 100644
index 000000000..6201887c1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/window/CursorShape.java
@@ -0,0 +1,10 @@
+package net.minecraft.client.render.window;
+
+public enum CursorShape {
+    ARROW,
+    I_BEAM,
+    CROSSHAIR,
+    HAND,
+    HORIZONTAL_RESIZE,
+    VERTICAL_RESIZE
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
index f33aaaea4..a9b0e1cd8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
@@ -5,32 +5,36 @@ import net.minecraft.core.UnexpectedThrowable;
 
 public interface GameWindow {
 	
-	public void init(Minecraft minecraft, int width, int height);
+	void init(Minecraft minecraft, int width, int height);
 	
-	public void toggleFullscreen();
+	void toggleFullscreen();
 	
-	public void updateWindowState();
+	void updateWindowState();
 	
-	public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause);
+	void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause);
 	
-	public int getFrequency();
+	int getFrequency();
 	
-	public void update();
+	void update();
 	
-	public boolean shouldClose();
+	boolean shouldClose();
 	
-	public int getWidthScreenCoords();
+	int getWidthScreenCoords();
 	
-	public int getHeightScreenCoords();
+	int getHeightScreenCoords();
 
-	public int getWidthPixels();
+	int getWidthPixels();
 
-	public int getHeightPixels();
+	int getHeightPixels();
 	
-	public boolean isFocused();
+	boolean isFocused();
 	
-	public boolean wasResized();
+	boolean wasResized();
 	
-	public void setVsync(boolean vsync);
+	void setVsync(boolean vsync);
+
+	void setCursorShape(CursorShape shape);
+
+	CursorShape getCursorShape();
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index ad24ed71f..adf316453 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -8,13 +8,18 @@ import java.awt.image.BufferedImage;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
 import java.nio.ByteBuffer;
+import java.util.HashMap;
+import java.util.Map;
 
 import javax.imageio.ImageIO;
 import javax.swing.JFrame;
 
+import com.mojang.logging.CategorizedLogger;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.Color;
 import org.lwjgl.PointerBuffer;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.glfw.GLFWImage;
 import org.lwjgl.glfw.GLFWVidMode;
 import org.lwjgl.input.Keyboard;
@@ -32,6 +37,8 @@ import net.minecraft.client.render.PanelCrashReport;
 import net.minecraft.core.UnexpectedThrowable;
 
 public class GameWindowGLFW implements GameWindow {
+    public static final CategorizedLogger LOGGER = LogUtils.getLogger();
+
     public Minecraft mc;
 
     public long window;
@@ -51,13 +58,16 @@ public class GameWindowGLFW implements GameWindow {
     private int widthPixels;
     private int heightPixels;
 
+    private final Map<CursorShape, Long> cursors = new HashMap<>();
+    private CursorShape currentCursor = CursorShape.ARROW;
+
     @Override
     public void init(Minecraft minecraft, int width, int height) {
         mc = minecraft;
 
-        System.out.println("GLFW Init");
+        LOGGER.info("Initializing GLFW...");
         if (!glfwInit()) {
-            throw new RuntimeException("GLFW Init failed!");
+            throw new RuntimeException("GLFW initialization failed!");
         }
 
         // Set window hints
@@ -112,7 +122,7 @@ public class GameWindowGLFW implements GameWindow {
                 int res = resolutions[i];
                 ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
                 if (icon == null) {
-                    System.err.println("Icon at resolution '" + res + "' is null! Skipping icons!");
+                    LOGGER.error("Icon at resolution '" + res + "' is null! Skipping icons!");
                     gb.close();
                     break iconLabel;
                 }
@@ -160,6 +170,46 @@ public class GameWindowGLFW implements GameWindow {
         setVsync(mc.gameSettings.enableVsync.value);
     }
 
+    @Override
+    public void setCursorShape(CursorShape shape) {
+        final int shapeVal;
+        switch (shape) {
+            case ARROW:
+                shapeVal = GLFW_ARROW_CURSOR;
+                break;
+            case I_BEAM:
+                shapeVal = GLFW_IBEAM_CURSOR;
+                break;
+            case CROSSHAIR:
+                shapeVal = GLFW_CROSSHAIR_CURSOR;
+                break;
+            case HAND:
+                shapeVal = GLFW_HAND_CURSOR;
+                break;
+            case HORIZONTAL_RESIZE:
+                shapeVal = GLFW_HRESIZE_CURSOR;
+                break;
+            case VERTICAL_RESIZE:
+                shapeVal = GLFW_VRESIZE_CURSOR;
+                break;
+            default:
+                return;
+        }
+        if (this.cursors.containsKey(shape)) {
+            GLFW.glfwSetCursor(this.window, this.cursors.get(shape));
+        } else {
+            long cursor = GLFW.glfwCreateStandardCursor(shapeVal);
+            this.cursors.put(shape, cursor);
+            GLFW.glfwSetCursor(this.window, cursor);
+        }
+        this.currentCursor = shape;
+    }
+
+    @Override
+    public CursorShape getCursorShape() {
+        return this.currentCursor;
+    }
+
     @Override
     public void toggleFullscreen() {
         mc.gameSettings.fullscreen.value = !mc.gameSettings.fullscreen.value;
@@ -190,7 +240,7 @@ public class GameWindowGLFW implements GameWindow {
         glfwHideWindow(window);
 
         if (fullscreen && !borderless) {
-            System.out.println("Change to Fullscreen");
+            LOGGER.info("Setting window to FULLSCREEN...");
             int x = windowPosX + windowWidth / 2;
             int y = windowPosY + windowHeight / 2;
             MonitorInfo monitor = getMonitorAt(x, y);
@@ -203,7 +253,7 @@ public class GameWindowGLFW implements GameWindow {
             glfwSetWindowMonitor(window, 0, windowPosX, windowPosY, windowWidth, windowHeight, 0);
 
             if (fullscreen && borderless) {
-                System.out.println("Change to Borderless Fullscreen");
+                LOGGER.info("Setting window to BORDERLESS FULLSCREEN...");
                 int x = windowPosX + windowWidth / 2;
                 int y = windowPosY + windowHeight / 2;
                 MonitorInfo monitor = getMonitorAt(x, y);
@@ -213,7 +263,7 @@ public class GameWindowGLFW implements GameWindow {
                 glfwSetWindowSize(window, monitor.widthScreenCoords, monitor.heightScreenCoords);
                 isFullscreen = true;
             } else {
-                System.out.println("Change to Windowed");
+                LOGGER.info("Setting window to WINDOWED...");
                 glfwSetWindowAttrib(window, GLFW_DECORATED, 1);
                 isFullscreen = false;
             }
@@ -376,8 +426,7 @@ public class GameWindowGLFW implements GameWindow {
             buf.flip();
             return buf;
         } catch (Exception e) {
-            System.out.println("Couldn't open icon image...");
-            e.printStackTrace();
+            LOGGER.warn("Couldn't open icon image.", e);
             return null;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
index 6754f6a2f..d98f60e94 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.worldtype;
 
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.type.WorldType;
@@ -72,4 +73,6 @@ public class WorldTypeFX {
     public float[] getSunriseColor(float timeOfDay, float partialTick) {
         return new float[4];
     }
+
+    public void playerAnimationTick(World world, Player player) { }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index 9c7e606a1..fbd35c2bb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -1,9 +1,13 @@
 package net.minecraft.client.render.worldtype;
 
 import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.type.WorldType;
 
 public class WorldTypeFXNether extends WorldTypeFX{
@@ -30,6 +34,47 @@ public class WorldTypeFXNether extends WorldTypeFX{
             float b = (color & 0xFF) / 255.0f;
             return Vec3.getTempVec3(r, g, b);
         }
-        return Vec3.getTempVec3(0.0, 0.0, 0.0);
+
+        float r = 60 / 255.0f;
+        float g = 0 / 255.0f;
+        float b = 0 / 255.0f;
+
+        double temp = ((BiomeProviderNether) world.getBiomeProvider()).getTemperature(x, z);
+
+        if (temp < 0.25) {
+            r = 0.0f;
+            g = 0.0f;
+            b = 0.0f;
+        } else if (temp < 0.5) {
+            double toLerp = temp - 0.25; // 0 - 0.25
+            toLerp *= 4; // 0 - 1
+            r = MathHelper.lerp(0, r, (float) toLerp);
+            g = MathHelper.lerp(0, g, (float) toLerp);
+            b = MathHelper.lerp(0, b, (float) toLerp);
+        }
+
+        return Vec3.getTempVec3(r, g, b);
+    }
+
+    @Override
+    public void playerAnimationTick(World world, Player player) {
+        final int radius = 12;
+
+        double x = player.x;
+        double y = player.y;
+        double z = player.z;
+
+        Biome localBiome = world.getBlockBiome((int) x, (int) y, (int) z);
+        if (localBiome == Biomes.NETHER_ASH_PLAINS || localBiome == Biomes.NETHER_BONEYARD) {
+            for (int i = 0; i < 5; i++) {
+                double rx = (x - radius) + (world.rand.nextDouble() * radius * 2);
+                double ry = (y - radius) + (world.rand.nextDouble() * radius * 2);
+                double rz = (z - radius) + (world.rand.nextDouble() * radius * 2);
+
+                if (world.getBlockId((int) rx, (int) ry, (int) rz) == 0) {
+                    world.spawnParticle("ashmote", rx, ry, rz, 0, 0, 0, 0);
+                }
+            }
+        }
     }
 }
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background.png.mcmeta
new file mode 100644
index 000000000..090d89c82
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 15,
+            "height": 15,
+            "border": {
+                "top": 5,
+                "left": 5,
+                "right": 5,
+                "bottom": 5
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background_embedded.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background_embedded.png.mcmeta
new file mode 100644
index 000000000..090d89c82
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/screen/keyboard/keyboard_background_embedded.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 15,
+            "height": 15,
+            "border": {
+                "top": 5,
+                "left": 5,
+                "right": 5,
+                "bottom": 5
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down.png.mcmeta
new file mode 100644
index 000000000..6fbdb3c28
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 18,
+            "height": 18,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down_hovered.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down_hovered.png.mcmeta
new file mode 100644
index 000000000..6fbdb3c28
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/down_hovered.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 18,
+            "height": 18,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up.png.mcmeta
new file mode 100644
index 000000000..6fbdb3c28
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 18,
+            "height": 18,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up_hovered.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up_hovered.png.mcmeta
new file mode 100644
index 000000000..6fbdb3c28
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/keyboard/key/up_hovered.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 18,
+            "height": 18,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/bind.bsh b/game/client/src/main/resources/scripts/beanshell/commands/bind.bsh
new file mode 100644
index 000000000..06da229b5
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/bind.bsh
@@ -0,0 +1,8 @@
+import net.minecraft.client.console.shell.BindManager;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+import org.lwjgl.input.Keyboard;
+
+RawOutputWrapper bind(int key, Runnable action) {
+    BindManager.getInstance().bindKeyToAction(key, action);
+    return new RawOutputWrapper("Bound key to action.");
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/logDisable.bsh b/game/client/src/main/resources/scripts/beanshell/commands/logDisable.bsh
new file mode 100644
index 000000000..5d0b45cf9
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/logDisable.bsh
@@ -0,0 +1,7 @@
+import com.mojang.logging.CategorizedLogger;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+
+RawOutputWrapper logDisable(String category) {
+    CategorizedLogger.setCategoryEnabled(category, false);
+    return new RawOutputWrapper("Disabled logging category " + category);
+}
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/logEnable.bsh b/game/client/src/main/resources/scripts/beanshell/commands/logEnable.bsh
new file mode 100644
index 000000000..8c0af291e
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/logEnable.bsh
@@ -0,0 +1,7 @@
+import com.mojang.logging.CategorizedLogger;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+
+RawOutputWrapper logEnable(String category) {
+    CategorizedLogger.setCategoryEnabled(category, true);
+    return new RawOutputWrapper("Enabled logging category " + category);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/logList.bsh b/game/client/src/main/resources/scripts/beanshell/commands/logList.bsh
new file mode 100644
index 000000000..40e1323eb
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/logList.bsh
@@ -0,0 +1,12 @@
+import com.mojang.logging.CategorizedLogger;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+
+RawOutputWrapper logList() {
+    Collection categories = CategorizedLogger.getKnownCategories();
+    if (categories.isEmpty()) return new RawOutputWrapper("No logging categories");
+    StringBuilder sb = new StringBuilder();
+    for (String str : categories) {
+        sb.append(" - ").append(str);
+    }
+    return new RawOutputWrapper(sb.toString());
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/mc.bsh b/game/client/src/main/resources/scripts/beanshell/commands/mc.bsh
new file mode 100644
index 000000000..c561b1bec
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/mc.bsh
@@ -0,0 +1,5 @@
+import net.minecraft.client.Minecraft;
+
+Minecraft mc() {
+    return Minecraft.getMinecraft();
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/scripts/beanshell/commands/unbind.bsh b/game/client/src/main/resources/scripts/beanshell/commands/unbind.bsh
new file mode 100644
index 000000000..5ff9b25b8
--- /dev/null
+++ b/game/client/src/main/resources/scripts/beanshell/commands/unbind.bsh
@@ -0,0 +1,7 @@
+import net.minecraft.client.console.shell.BindManager;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+
+RawOutputWrapper unbind(int key) {
+    BindManager.getInstance().bindKeyToAction(key, null);
+    return new RawOutputWrapper("Unbound key.");
+{
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
new file mode 100644
index 000000000..4a2114544
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
@@ -0,0 +1,30 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockLogicAsh extends BlockLogic
+{
+
+	public BlockLogicAsh(Block<?> block)
+    {
+        super(block, Material.ash);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
+    {
+        switch (dropCause)
+        {
+            case PICK_BLOCK:
+            case SILK_TOUCH:
+                return new ItemStack[] { new ItemStack(this) };
+            default:
+//                return new ItemStack[] { new ItemStack(Items.AMMO_SNOWBALL, 4) };
+                return null;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java
new file mode 100644
index 000000000..ea7486d79
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java
@@ -0,0 +1,18 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockLogicCrystal extends BlockLogicTransparent
+{
+
+    public BlockLogicCrystal(Block<?> block)
+    {
+        super(block, Material.glass);
+    }
+
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+        return 1f;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index fee3177ac..ea9cf35b6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
@@ -145,7 +146,7 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 		{
 			if (entity instanceof Player)
 			{
-				if (((Player) entity).inventory.armorInventory[IArmorItem.PIECE_BOOTS] != null && ((Player) entity).inventory.armorInventory[IArmorItem.PIECE_BOOTS].getItem() == Items.ARMOR_BOOTS_LEATHER) {
+				if (((Player) entity).getItemInArmorSlot(HumanArmorShape.BOOTS) != null && ((Player) entity).getItemInArmorSlot(HumanArmorShape.BOOTS).getItem() == Items.ARMOR_BOOTS_LEATHER) {
 					return;
 				}
 				if(isWet(world.getBlockMetadata(x, y, z)))
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 65b9cc09c..87de3a52e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -219,7 +219,7 @@ public class BlockLogicFire extends BlockLogic {
 		}
 	}
 
-	private boolean canNeighborCatchFire(World world, int x, int y, int z) {
+	protected boolean canNeighborCatchFire(World world, int x, int y, int z) {
 		if (canBurn(world, x + 1, y, z)) return true;
 		if (canBurn(world, x - 1, y, z)) return true;
 		if (canBurn(world, x, y - 1, z)) return true;
